--- src/backend/access/heap/heapam.c.orig	2014-08-18 14:10:36.841016638 -0400
+++ src/backend/access/heap/heapam.c	2014-08-19 16:56:13.795197558 -0400
@@ -71,6 +71,28 @@
 #include "utils/syscache.h"
 #include "utils/tqual.h"
 
+#ifdef USE_PREFETCH
+#include <sys/types.h>
+#include <unistd.h>
+#include <stdlib.h>
+#include <stdio.h>
+
+#include "executor/instrument.h"
+
+extern unsigned int prefetch_dbOid; /*  database oid of relations on which prefetching to be done - 0 means all */
+extern unsigned int prefetch_heap_scans; /*  boolean whether to prefetch non-bitmap heap scans         */
+
+/*  special values for scan->rs_prefetch_target indicating as follows :               */
+#define PREFETCH_MAYBE 0xffffffff      /*   prefetch permitted but not yet in effect  */
+#define PREFETCH_DISABLED 0xfffffffe   /*   prefetch disabled and not permitted       */
+/*  PREFETCH_WRAP_POINT indicates a pretcher who has reached the point where the scan would wrap -
+**  at this point the prefetcher runs on the spot until scan catches up.
+**  This *must* be < maximum valid setting of target_prefetch_pages aka effective_io_concurrency.
+*/
+#define PREFETCH_WRAP_POINT 0x0fffffff
+
+#endif   /* USE_PREFETCH */
+
 
 /* GUC variable */
 bool		synchronize_seqscans = true;
@@ -115,6 +137,10 @@ static XLogRecPtr log_heap_new_cid(Relat
 static HeapTuple ExtractReplicaIdentity(Relation rel, HeapTuple tup, bool key_modified,
 					   bool *copy);
 
+#ifdef USE_PREFETCH
+static void heap_unread_add(HeapScanDesc scan, BlockNumber blockno);
+static void heap_unread_subtract(HeapScanDesc scan, BlockNumber blockno);
+#endif   /* USE_PREFETCH */
 
 /*
  * Each tuple lock mode has a corresponding heavyweight lock, and one or two
@@ -292,9 +318,150 @@ initscan(HeapScanDesc scan, ScanKey key,
 	 * Currently, we don't have a stats counter for bitmap heap scans (but the
 	 * underlying bitmap index scans will be counted).
 	 */
-	if (!scan->rs_bitmapscan)
+#ifdef USE_PREFETCH
+        /*    by default,  no prefetching on any scan  */
+        scan->rs_prefetch_target = PREFETCH_DISABLED;  /*  tentatively disable  */
+        scan->rs_pfchblock = 0; /*  scanner will reset this to be ahead of scan */
+        scan->rs_Unread_Pfetched_base = (BlockNumber *)0; /*  list of prefetched but unread blocknos */
+        scan->rs_Unread_Pfetched_next = 0; /*  next unread blockno */
+        scan->rs_Unread_Pfetched_count = 0; /* number of valid unread blocknos */
+#endif   /* USE_PREFETCH */
+	if (!scan->rs_bitmapscan) {
+
 		pgstat_count_heap_scan(scan->rs_rd);
+#ifdef USE_PREFETCH
+                /*    bitmap scans do their own prefetching -
+                **    for others,  set up prefetching now
+                */
+                if (    prefetch_heap_scans
+                     && (target_prefetch_pages > 0)
+                     &&	(!RelationUsesLocalBuffers(scan->rs_rd))
+                   ) {
+                      /*   prefetch_dbOid may be set to a database Oid to specify only prefetch in that db */
+                      if (    (   (prefetch_dbOid > 0)
+                               && (prefetch_dbOid == scan->rs_rd->rd_node.dbNode)
+                              )
+                          ||  (prefetch_dbOid == 0)
+                         ) {
+                          scan->rs_prefetch_target = PREFETCH_MAYBE;    /*  permitted but let the scan decide */
+                      }
+                      else {
+                      }
 }
+#endif   /* USE_PREFETCH */
+        }
+}
+
+#ifdef USE_PREFETCH
+/* add this blockno to list of prefetched and unread blocknos
+** use the one identified by the (next+count|modulo circumference) index if it is unused,
+** else search for the first available slot if there is one,
+** else error.
+*/
+static void
+heap_unread_add(HeapScanDesc scan, BlockNumber blockno)
+{
+      BlockNumber *available_P;   /*  where to store new blockno */
+      unsigned int Unread_Pfetched_index = scan->rs_Unread_Pfetched_next
+                                         + scan->rs_Unread_Pfetched_count; /* index of next unused slot */
+
+      /*  caller is not supposed to pass InvalidBlockNumber but check anyway */
+      if (blockno != InvalidBlockNumber) {
+
+		  /*  ensure there is some room somewhere   */
+		  if (scan->rs_Unread_Pfetched_count < target_prefetch_pages) {
+
+			  /*  try the "next+count" one */
+			  if (Unread_Pfetched_index >= target_prefetch_pages) {
+				  Unread_Pfetched_index -= target_prefetch_pages;  /* modulo circumference */
+			  }
+			  available_P = (scan->rs_Unread_Pfetched_base + Unread_Pfetched_index);   /*  where to store new blockno */
+			  if (*available_P == InvalidBlockNumber) { /* unused */
+				  goto store_blockno;
+			  } else {
+                  /*  slow-search the entire list  */
+				  for (Unread_Pfetched_index = 0; Unread_Pfetched_index < target_prefetch_pages; Unread_Pfetched_index++) {
+					  available_P = (scan->rs_Unread_Pfetched_base + Unread_Pfetched_index);   /*  where to store new blockno */
+					  if (*available_P == InvalidBlockNumber) { /* unused */
+                          /*  before storing this blockno,
+                          **  since the next pointer did not locate an unused slot,
+                          **  set it to one which is more likely to be so for the next time
+                          */
+                          scan->rs_Unread_Pfetched_next = Unread_Pfetched_index;
+						  goto store_blockno;
+					  }
+				  }
+			  }
+		  }
+
+          /*  if we reach here,    either there was no available slot
+          **  or we thought there was one and didn't find any  --
+          */
+  		  ereport(NOTICE,
+			  (errcode(ERRCODE_INTERNAL_ERROR),
+                                errmsg("heap_unread_add overflowed list cannot add blockno %d", blockno)));
+
+  		  return;
+
+    store_blockno:
+		  *available_P = blockno;
+		  scan->rs_Unread_Pfetched_count++;  /*  update count */
+
+	  }
+
+    return;
+}
+
+/* remove specified blockno from list of prefetched and unread blocknos.
+** Usually this will be found at the rs_Unread_Pfetched_next item -
+** else search for it.    If not found,   inore it  -  no error results.
+*/
+static void
+heap_unread_subtract(HeapScanDesc scan, BlockNumber blockno)
+{
+      unsigned int Unread_Pfetched_index = scan->rs_Unread_Pfetched_next; /* index of next unread blockno */
+      BlockNumber *candidate_P;   /*  location of callers blockno - maybe */
+      BlockNumber nextUnreadPfetched;
+
+      /*  caller is not supposed to pass InvalidBlockNumber but check anyway */
+      if (    (blockno != InvalidBlockNumber)
+		   && ( scan->rs_Unread_Pfetched_count > 0 )   /*  if the list is not empty  */
+         ) {
+
+			  /*  take modulo of the circumference.
+			  **  actually rs_Unread_Pfetched_next should never exceed the circumference but check anyway.
+			  */
+			  if (Unread_Pfetched_index >= target_prefetch_pages) {
+				  Unread_Pfetched_index  -= target_prefetch_pages;
+}
+			  candidate_P = (scan->rs_Unread_Pfetched_base + Unread_Pfetched_index);
+			  nextUnreadPfetched = *candidate_P;
+
+			  if ( nextUnreadPfetched == blockno ) {
+				  goto remove_blockno;
+			  } else {
+                  /*  slow-search the entire list  */
+				  for (Unread_Pfetched_index = 0; Unread_Pfetched_index < target_prefetch_pages; Unread_Pfetched_index++) {
+					  candidate_P = (scan->rs_Unread_Pfetched_base + Unread_Pfetched_index);   /*  where to store new blockno */
+					  if (*candidate_P == blockno) { /* unused */
+						  goto remove_blockno;
+					  }
+				  }
+			  }
+
+    remove_blockno:
+			  *candidate_P = InvalidBlockNumber;
+
+			  scan->rs_Unread_Pfetched_next = (Unread_Pfetched_index+1);  /*  update next pfchd unread */
+			  if (scan->rs_Unread_Pfetched_next >= target_prefetch_pages) {
+					  scan->rs_Unread_Pfetched_next = 0;
+			  }
+			  scan->rs_Unread_Pfetched_count--;  /*  update count */
+	  }
+
+      return;
+}
+#endif   /* USE_PREFETCH */
 
 /*
  * heapgetpage - subroutine for heapgettup()
@@ -304,7 +471,7 @@ initscan(HeapScanDesc scan, ScanKey key,
  * which tuples on the page are visible.
  */
 static void
-heapgetpage(HeapScanDesc scan, BlockNumber page)
+heapgetpage(HeapScanDesc scan, BlockNumber page , BlockNumber prefetchHWM)
 {
 	Buffer		buffer;
 	Snapshot	snapshot;
@@ -314,6 +481,10 @@ heapgetpage(HeapScanDesc scan, BlockNumb
 	OffsetNumber lineoff;
 	ItemId		lpp;
 	bool		all_visible;
+#ifdef USE_PREFETCH
+	int             PrefetchBufferRc;  /*   indicates whether requested prefetch block already in a buffer and if pin count on buffer has been increased */
+#endif   /* USE_PREFETCH */
+
 
 	Assert(page < scan->rs_nblocks);
 
@@ -336,6 +507,98 @@ heapgetpage(HeapScanDesc scan, BlockNumb
 									   RBM_NORMAL, scan->rs_strategy);
 	scan->rs_cblock = page;
 
+#ifdef USE_PREFETCH
+
+        heap_unread_subtract(scan, page);
+
+        /*    maybe prefetch some pages  starting with rs_pfchblock */
+        if (scan->rs_prefetch_target >= 0) {       /*   prefetching enabled on this scan ?                         */
+            int next_block_to_be_read = (page+1);  /*   next block to be read = lowest possible prefetchable block */
+            int num_to_pfch_this_time;             /*   eventually holds the number of blocks to prefetch now      */
+            int prefetchable_range;                /*   size of the area ahead of the current prefetch position    */
+
+            /*  check if prefetcher reached wrap point and the scan has now wrapped */
+            if (  (page == 0) && (scan->rs_prefetch_target == PREFETCH_WRAP_POINT)  ) {
+                scan->rs_prefetch_target = 1;
+                scan->rs_pfchblock = next_block_to_be_read;
+            } else
+            if (scan->rs_pfchblock < next_block_to_be_read) {
+                scan->rs_pfchblock = next_block_to_be_read; /* next block to be prefetched must be ahead of one we just read */
+            }
+
+            /* now we know where we would start prefetching -
+            ** next question   -  if this is a sync scan,  ensure we do not prefetch behind the HWM
+            ** debatable whether to require strict inequality or >=  -   >= works better in practice
+            */
+            if ( (!scan->rs_syncscan) || (scan->rs_pfchblock >= prefetchHWM) ) {
+
+                /* now we know where we will start prefetching -
+                ** next question   -  how many?
+                ** apply two limits :
+                **  1.   target prefetch distance
+                **  2.   number of available blocks ahead of us
+                */
+
+                /*  1.   target prefetch distance   */
+                num_to_pfch_this_time = next_block_to_be_read + scan->rs_prefetch_target; /* page beyond prefetch target */
+                num_to_pfch_this_time -= scan->rs_pfchblock;                              /*  convert to offset        */
+
+                /*   first do prefetching up to our current limit  ...
+                **   highest page number that a scan (pre)-fetches is scan->rs_nblocks-1
+                **   note  -  prefetcher does not wrap a prefetch range -
+                **            instead just stop and then start again if and when main scan wraps
+                */
+                if (scan->rs_pfchblock <= scan->rs_startblock) {  /*  if on second leg towards startblock */
+                    prefetchable_range = ((int)(scan->rs_startblock) - (int)(scan->rs_pfchblock));
+                }
+                else {                                            /*     on first leg towards nblocks     */
+                    prefetchable_range = ((int)(scan->rs_nblocks) - (int)(scan->rs_pfchblock));
+                }
+                if (prefetchable_range > 0) {           /*  if theres a range to prefetch */
+
+                    /*  2.   number of available blocks ahead of us        */
+                    if (num_to_pfch_this_time > prefetchable_range) {
+                        num_to_pfch_this_time = prefetchable_range;
+                    }
+                    while (num_to_pfch_this_time-- > 0) {
+                        PrefetchBufferRc = PrefetchBuffer(scan->rs_rd, MAIN_FORKNUM, scan->rs_pfchblock, scan->rs_strategy);
+                        /*  if pin acquired on buffer,  then remember in case of future Discard */
+                        if (PrefetchBufferRc & PREFTCHRC_BUF_PIN_INCREASED) {
+                            heap_unread_add(scan, scan->rs_pfchblock);
+						}
+                        scan->rs_pfchblock++;
+                        /*  if syncscan and requested block was already in buffer pool,
+                        **  this suggests that another scanner is ahead of us and we should advance
+                        */
+                        if ( (scan->rs_syncscan) && (PrefetchBufferRc & PREFTCHRC_BLK_ALREADY_PRESENT) ) {
+                            scan->rs_pfchblock++;
+                            num_to_pfch_this_time--;
+                        }
+                    }
+                }
+                else {
+                    /*   we must not modify scan->rs_pfchblock here
+                    **   because it is needed for possible DiscardBuffer at end of scan  ...
+                    **   ... instead ...
+                    */
+                    scan->rs_prefetch_target = PREFETCH_WRAP_POINT;  /*   mark this prefetcher as waiting to wrap */
+                }
+
+                /*   ...  then adjust prefetching limit : by doubling on each iteration */
+                if (scan->rs_prefetch_target == 0) {
+                    scan->rs_prefetch_target = 1;
+                }
+                else {
+                    scan->rs_prefetch_target *= 2;
+                    if (scan->rs_prefetch_target > target_prefetch_pages) {
+                        scan->rs_prefetch_target = target_prefetch_pages;
+                    }
+                }
+            }
+        }
+#endif   /* USE_PREFETCH */
+
+
 	if (!scan->rs_pageatatime)
 		return;
 
@@ -452,6 +715,10 @@ heapgettup(HeapScanDesc scan,
 	OffsetNumber lineoff;
 	int			linesleft;
 	ItemId		lpp;
+    BlockNumber  prefetchHWM = 0;   /*  HWM of prefetch BlockNum for all participants in same sync scan */
+#ifdef USE_PREFETCH
+    int          ix;
+#endif   /* USE_PREFETCH */
 
 	/*
 	 * calculate next starting lineoff, given scan direction
@@ -470,7 +737,25 @@ heapgettup(HeapScanDesc scan,
 				return;
 			}
 			page = scan->rs_startblock; /* first page */
-			heapgetpage(scan, page);
+#ifdef USE_PREFETCH
+                        /*  decide if we shall do prefetching :  only if :
+                        **   .  prefetching enabled for this scan
+                        **   .  not a bitmap scan (which do their own)
+                        **   .  sufficient number of blocks - at least twice the target_prefetch_pages
+                        */
+                        if (    (!scan->rs_bitmapscan)
+                             && (scan->rs_prefetch_target >= PREFETCH_MAYBE)
+                             && (scan->rs_nblocks > (2*target_prefetch_pages))
+                           )  {
+                                scan->rs_prefetch_target = 1;  /*  do prefetching on forward non-bitmap scan */
+                                scan->rs_Unread_Pfetched_base = (BlockNumber *)palloc(sizeof(BlockNumber)*target_prefetch_pages);
+                                /*  Initialise the list */
+                                for (ix = 0; ix < target_prefetch_pages; ix++) {
+									*(scan->rs_Unread_Pfetched_base + ix) = InvalidBlockNumber;
+								}
+                        }
+#endif   /* USE_PREFETCH */
+			heapgetpage(scan, page, prefetchHWM);
 			lineoff = FirstOffsetNumber;		/* first offnum */
 			scan->rs_inited = true;
 		}
@@ -516,7 +801,7 @@ heapgettup(HeapScanDesc scan,
 				page = scan->rs_startblock - 1;
 			else
 				page = scan->rs_nblocks - 1;
-			heapgetpage(scan, page);
+			heapgetpage(scan, page, prefetchHWM);
 		}
 		else
 		{
@@ -557,7 +842,7 @@ heapgettup(HeapScanDesc scan,
 
 		page = ItemPointerGetBlockNumber(&(tuple->t_self));
 		if (page != scan->rs_cblock)
-			heapgetpage(scan, page);
+			heapgetpage(scan, page, prefetchHWM);
 
 		/* Since the tuple was previously fetched, needn't lock page here */
 		dp = (Page) BufferGetPage(scan->rs_cbuf);
@@ -660,8 +945,12 @@ heapgettup(HeapScanDesc scan,
 			 * a little bit backwards on every invocation, which is confusing.
 			 * We don't guarantee any specific ordering in general, though.
 			 */
-			if (scan->rs_syncscan)
-				ss_report_location(scan->rs_rd, page);
+			if (scan->rs_syncscan) {
+#ifdef USE_PREFETCH
+				prefetchHWM = scan->rs_pfchblock;
+#endif   /* USE_PREFETCH */
+				ss_report_location(scan->rs_rd, page, &prefetchHWM);
+			}
 		}
 
 		/*
@@ -671,6 +960,22 @@ heapgettup(HeapScanDesc scan,
 		{
 			if (BufferIsValid(scan->rs_cbuf))
 				ReleaseBuffer(scan->rs_cbuf);
+#ifdef USE_PREFETCH
+                        if (  (scan->rs_pfchblock > 0) && (scan->rs_cblock != InvalidBlockNumber)  ) {
+                            BlockNumber *Unread_Pfetched_base = scan->rs_Unread_Pfetched_base;
+                            unsigned int Unread_Pfetched_next = scan->rs_Unread_Pfetched_next;   /*  where the next unread blockno is relative to start */
+                            unsigned int Unread_Pfetched_count = scan->rs_Unread_Pfetched_count;
+
+                            /*  we have prefetched but not read the range from cblock+1 to pfchblock-1 if that is non-empty */
+                            while ((Unread_Pfetched_count--) > 0) {
+                                DiscardBuffer( scan->rs_rd, MAIN_FORKNUM, *(Unread_Pfetched_base+Unread_Pfetched_next));
+                                heap_unread_subtract(scan, *(Unread_Pfetched_base+Unread_Pfetched_next)); /* remove this blockno from list of prefetched and unread blocknos */
+                                Unread_Pfetched_next++;
+                                if (Unread_Pfetched_next >= target_prefetch_pages)
+                                    Unread_Pfetched_next = 0;
+                            }
+                        }
+#endif   /* USE_PREFETCH */
 			scan->rs_cbuf = InvalidBuffer;
 			scan->rs_cblock = InvalidBlockNumber;
 			tuple->t_data = NULL;
@@ -678,7 +983,7 @@ heapgettup(HeapScanDesc scan,
 			return;
 		}
 
-		heapgetpage(scan, page);
+		heapgetpage(scan, page, prefetchHWM);
 
 		LockBuffer(scan->rs_cbuf, BUFFER_LOCK_SHARE);
 
@@ -727,6 +1032,10 @@ heapgettup_pagemode(HeapScanDesc scan,
 	OffsetNumber lineoff;
 	int			linesleft;
 	ItemId		lpp;
+    BlockNumber  prefetchHWM = 0;   /*  HWM of prefetch BlockNum for all participants in same sync scan */
+#ifdef USE_PREFETCH
+    int          ix;
+#endif   /* USE_PREFETCH */
 
 	/*
 	 * calculate next starting lineindex, given scan direction
@@ -745,7 +1054,25 @@ heapgettup_pagemode(HeapScanDesc scan,
 				return;
 			}
 			page = scan->rs_startblock; /* first page */
-			heapgetpage(scan, page);
+#ifdef USE_PREFETCH
+                        /*  decide if we shall do prefetching :  only if :
+                        **   .  prefetching enabled for this scan
+                        **   .  not a bitmap scan (which do their own)
+                        **   .  sufficient number of blocks - at least twice the target_prefetch_pages
+                        */
+                        if (    (!scan->rs_bitmapscan)
+                             && (scan->rs_prefetch_target >= PREFETCH_MAYBE)
+                             && (scan->rs_nblocks > (2*target_prefetch_pages))
+                           )  {
+                                scan->rs_prefetch_target = 1;  /*  do prefetching on forward non-bitmap scan */
+                                scan->rs_Unread_Pfetched_base = (BlockNumber *)palloc(sizeof(BlockNumber)*target_prefetch_pages);
+                                /*  Initialise the list */
+                                for (ix = 0; ix < target_prefetch_pages; ix++) {
+									*(scan->rs_Unread_Pfetched_base + ix) = InvalidBlockNumber;
+								}
+                        }
+#endif   /* USE_PREFETCH */
+			heapgetpage(scan, page, prefetchHWM);
 			lineindex = 0;
 			scan->rs_inited = true;
 		}
@@ -788,7 +1115,7 @@ heapgettup_pagemode(HeapScanDesc scan,
 				page = scan->rs_startblock - 1;
 			else
 				page = scan->rs_nblocks - 1;
-			heapgetpage(scan, page);
+			heapgetpage(scan, page, prefetchHWM);
 		}
 		else
 		{
@@ -826,7 +1153,7 @@ heapgettup_pagemode(HeapScanDesc scan,
 
 		page = ItemPointerGetBlockNumber(&(tuple->t_self));
 		if (page != scan->rs_cblock)
-			heapgetpage(scan, page);
+			heapgetpage(scan, page, prefetchHWM);
 
 		/* Since the tuple was previously fetched, needn't lock page here */
 		dp = (Page) BufferGetPage(scan->rs_cbuf);
@@ -921,8 +1248,12 @@ heapgettup_pagemode(HeapScanDesc scan,
 			 * a little bit backwards on every invocation, which is confusing.
 			 * We don't guarantee any specific ordering in general, though.
 			 */
-			if (scan->rs_syncscan)
-				ss_report_location(scan->rs_rd, page);
+			if (scan->rs_syncscan) {
+#ifdef USE_PREFETCH
+				prefetchHWM = scan->rs_pfchblock;
+#endif   /* USE_PREFETCH */
+				ss_report_location(scan->rs_rd, page, &prefetchHWM);
+			}
 		}
 
 		/*
@@ -932,6 +1263,22 @@ heapgettup_pagemode(HeapScanDesc scan,
 		{
 			if (BufferIsValid(scan->rs_cbuf))
 				ReleaseBuffer(scan->rs_cbuf);
+#ifdef USE_PREFETCH
+                        if (  (scan->rs_pfchblock > 0) && (scan->rs_cblock != InvalidBlockNumber)  ) {
+                            BlockNumber *Unread_Pfetched_base = scan->rs_Unread_Pfetched_base;
+                            unsigned int Unread_Pfetched_next = scan->rs_Unread_Pfetched_next;   /*  where the next unread blockno is relative to start */
+                            unsigned int Unread_Pfetched_count = scan->rs_Unread_Pfetched_count;
+
+                            /*  we have prefetched but not read the range from cblock+1 to pfchblock-1 if that is non-empty */
+                             while ((Unread_Pfetched_count--) > 0) {
+                                DiscardBuffer( scan->rs_rd, MAIN_FORKNUM, *(Unread_Pfetched_base+Unread_Pfetched_next));
+                                heap_unread_subtract(scan, *(Unread_Pfetched_base+Unread_Pfetched_next)); /* remove this blockno from list of prefetched and unread blocknos */
+                                Unread_Pfetched_next++;
+                                if (Unread_Pfetched_next >= target_prefetch_pages)
+                                    Unread_Pfetched_next = 0;
+                            }
+                        }
+#endif   /* USE_PREFETCH */
 			scan->rs_cbuf = InvalidBuffer;
 			scan->rs_cblock = InvalidBlockNumber;
 			tuple->t_data = NULL;
@@ -939,7 +1286,7 @@ heapgettup_pagemode(HeapScanDesc scan,
 			return;
 		}
 
-		heapgetpage(scan, page);
+		heapgetpage(scan, page, prefetchHWM);
 
 		dp = (Page) BufferGetPage(scan->rs_cbuf);
 		lines = scan->rs_ntuples;
@@ -1394,6 +1741,23 @@ void
 heap_rescan(HeapScanDesc scan,
 			ScanKey key)
 {
+
+#ifdef USE_PREFETCH
+         if (  (scan->rs_pfchblock > 0) && (scan->rs_cblock != InvalidBlockNumber)  ) {
+                            BlockNumber *Unread_Pfetched_base = scan->rs_Unread_Pfetched_base;
+                            unsigned int Unread_Pfetched_next = scan->rs_Unread_Pfetched_next;   /*  where the next unread blockno is relative to start */
+                            unsigned int Unread_Pfetched_count = scan->rs_Unread_Pfetched_count;
+
+                       /*  we have prefetched but not read the range from cblock+1 to pfchblock-1 if that is non-empty */
+                            while ((Unread_Pfetched_count--) > 0) {
+                                DiscardBuffer( scan->rs_rd, MAIN_FORKNUM, *(Unread_Pfetched_base+Unread_Pfetched_next));
+                                heap_unread_subtract(scan, *(Unread_Pfetched_base+Unread_Pfetched_next)); /* remove this blockno from list of prefetched and unread blocknos */
+                                Unread_Pfetched_next++;
+                                if (Unread_Pfetched_next >= target_prefetch_pages)
+                                    Unread_Pfetched_next = 0;
+                            }
+         }
+#endif   /* USE_PREFETCH */
 	/*
 	 * unpin scan buffers
 	 */
@@ -1418,6 +1782,23 @@ heap_endscan(HeapScanDesc scan)
 {
 	/* Note: no locking manipulations needed */
 
+
+#ifdef USE_PREFETCH
+         if (  (scan->rs_pfchblock > 0) && (scan->rs_cblock != InvalidBlockNumber)  ) {
+                            BlockNumber *Unread_Pfetched_base = scan->rs_Unread_Pfetched_base;
+                            unsigned int Unread_Pfetched_next = scan->rs_Unread_Pfetched_next;   /*  where the next unread blockno is relative to start */
+                            unsigned int Unread_Pfetched_count = scan->rs_Unread_Pfetched_count;
+
+                       /*  we have prefetched but not read the range from cblock+1 to pfchblock-1 if that is non-empty */
+                            while ((Unread_Pfetched_count--) > 0) {
+                                DiscardBuffer( scan->rs_rd, MAIN_FORKNUM, *(Unread_Pfetched_base+Unread_Pfetched_next));
+                                heap_unread_subtract(scan, *(Unread_Pfetched_base+Unread_Pfetched_next)); /* remove this blockno from list of prefetched and unread blocknos */
+                                Unread_Pfetched_next++;
+                                if (Unread_Pfetched_next >= target_prefetch_pages)
+                                    Unread_Pfetched_next = 0;
+                            }
+         }
+#endif   /* USE_PREFETCH */
 	/*
 	 * unpin scan buffers
 	 */
@@ -1435,6 +1816,12 @@ heap_endscan(HeapScanDesc scan)
 	if (scan->rs_strategy != NULL)
 		FreeAccessStrategy(scan->rs_strategy);
 
+#ifdef USE_PREFETCH
+    if (scan->rs_Unread_Pfetched_base) {
+        pfree(scan->rs_Unread_Pfetched_base);
+    }
+#endif   /* USE_PREFETCH */
+
 	if (scan->rs_temp_snap)
 		UnregisterSnapshot(scan->rs_snapshot);
 
@@ -1464,7 +1851,6 @@ heap_endscan(HeapScanDesc scan)
 #define HEAPDEBUG_3
 #endif   /* !defined(HEAPDEBUGALL) */
 
-
 HeapTuple
 heap_getnext(HeapScanDesc scan, ScanDirection direction)
 {
@@ -6364,6 +6750,25 @@ heap_markpos(HeapScanDesc scan)
 void
 heap_restrpos(HeapScanDesc scan)
 {
+
+
+#ifdef USE_PREFETCH
+                        if (  (scan->rs_pfchblock > 0) && (scan->rs_cblock != InvalidBlockNumber)  ) {
+                            BlockNumber *Unread_Pfetched_base = scan->rs_Unread_Pfetched_base;
+                            unsigned int Unread_Pfetched_next = scan->rs_Unread_Pfetched_next;   /*  where the next unread blockno is relative to start */
+                            unsigned int Unread_Pfetched_count = scan->rs_Unread_Pfetched_count;
+
+                            /*  we have prefetched but not read the range from cblock+1 to pfchblock-1 if that is non-empty */
+                             while ((Unread_Pfetched_count--) > 0) {
+                                DiscardBuffer( scan->rs_rd, MAIN_FORKNUM, *(Unread_Pfetched_base+Unread_Pfetched_next));
+                                heap_unread_subtract(scan, *(Unread_Pfetched_base+Unread_Pfetched_next)); /* remove this blockno from list of prefetched and unread blocknos */
+                                Unread_Pfetched_next++;
+                                if (Unread_Pfetched_next >= target_prefetch_pages)
+                                    Unread_Pfetched_next = 0;
+                            }
+                        }
+#endif   /* USE_PREFETCH */
+
 	/* XXX no amrestrpos checking that ammarkpos called */
 
 	if (!ItemPointerIsValid(&scan->rs_mctid))
--- src/backend/access/heap/syncscan.c.orig	2014-08-18 14:10:36.841016638 -0400
+++ src/backend/access/heap/syncscan.c	2014-08-19 16:56:13.835197702 -0400
@@ -90,6 +90,7 @@ typedef struct ss_scan_location_t
 {
 	RelFileNode relfilenode;	/* identity of a relation */
 	BlockNumber location;		/* last-reported location in the relation */
+	BlockNumber prefetchHWM;	/* high-water-mark of prefetched Blocknum */
 } ss_scan_location_t;
 
 typedef struct ss_lru_item_t
@@ -113,7 +114,7 @@ static ss_scan_locations_t *scan_locatio
 
 /* prototypes for internal functions */
 static BlockNumber ss_search(RelFileNode relfilenode,
-		  BlockNumber location, bool set);
+		  BlockNumber location, bool set , BlockNumber *prefetchHWMp);
 
 
 /*
@@ -160,6 +161,7 @@ SyncScanShmemInit(void)
 			item->location.relfilenode.dbNode = InvalidOid;
 			item->location.relfilenode.relNode = InvalidOid;
 			item->location.location = InvalidBlockNumber;
+			item->location.prefetchHWM = InvalidBlockNumber;
 
 			item->prev = (i > 0) ?
 				(&scan_locations->items[i - 1]) : NULL;
@@ -185,7 +187,7 @@ SyncScanShmemInit(void)
  * data structure.
  */
 static BlockNumber
-ss_search(RelFileNode relfilenode, BlockNumber location, bool set)
+ss_search(RelFileNode relfilenode, BlockNumber location, bool set , BlockNumber *prefetchHWMp)
 {
 	ss_lru_item_t *item;
 
@@ -206,6 +208,22 @@ ss_search(RelFileNode relfilenode, Block
 			{
 				item->location.relfilenode = relfilenode;
 				item->location.location = location;
+                                /*  if prefetch information requested,
+                                **  then reconcile and either update or report back the new HWM.
+                                */
+                                if (prefetchHWMp)
+                                {
+                                    if (   (item->location.prefetchHWM == InvalidBlockNumber)
+                                        || (item->location.prefetchHWM < *prefetchHWMp)
+                                       )
+                                    {
+                                      item->location.prefetchHWM = *prefetchHWMp;
+                                    }
+                                    else
+                                    {
+                                      *prefetchHWMp = item->location.prefetchHWM;
+                                    }
+                                }
 			}
 			else if (set)
 				item->location.location = location;
@@ -252,7 +270,7 @@ ss_get_location(Relation rel, BlockNumbe
 	BlockNumber startloc;
 
 	LWLockAcquire(SyncScanLock, LW_EXCLUSIVE);
-	startloc = ss_search(rel->rd_node, 0, false);
+	startloc = ss_search(rel->rd_node, 0, false , 0);
 	LWLockRelease(SyncScanLock);
 
 	/*
@@ -282,7 +300,7 @@ ss_get_location(Relation rel, BlockNumbe
  * same relfilenode.
  */
 void
-ss_report_location(Relation rel, BlockNumber location)
+ss_report_location(Relation rel, BlockNumber location , BlockNumber *prefetchHWMp)
 {
 #ifdef TRACE_SYNCSCAN
 	if (trace_syncscan)
@@ -306,7 +324,7 @@ ss_report_location(Relation rel, BlockNu
 	{
 		if (LWLockConditionalAcquire(SyncScanLock, LW_EXCLUSIVE))
 		{
-			(void) ss_search(rel->rd_node, location, true);
+			(void) ss_search(rel->rd_node, location, true , prefetchHWMp);
 			LWLockRelease(SyncScanLock);
 		}
 #ifdef TRACE_SYNCSCAN
